package com.maroontress.sanctuary;

import com.maroontress.sanctuary.desc.HtmlList;
import com.maroontress.sanctuary.desc.HtmlSpan;
import com.maroontress.sanctuary.desc.Tag;
import java.util.HashMap;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
   ɥȤǤ

   descǤбޤ
*/
public class Description {

    /** HTMLΥޥå */
    private static HashMap<String, Tag> htmlTagMap;

    /** TeXΥޥå */
    private static HashMap<String, Tag> texTagMap;

    /** desc */
    private Element descElem;

    /** ̻ҥޥ͡ */
    private IDManager idManager;

    /** descǤ°ѥå̾ */
    private String packageName;

    /**
       descǤ°̾֡ʥѥå̾ + "." + 饹̾ޤ
       󥿥ե̾
    */
    private String namespace;

    static {
	HashMap<String, Tag> map;

	map = new HashMap<String, Tag>();
	map.put("code",	new HtmlSpan("code"));
	map.put("arg", new HtmlSpan("arg"));
	map.put("em", new HtmlSpan("em"));
	map.put("note", new HtmlList("Note:"));
	map.put("see", new HtmlList("See:"));
	map.put("p", new Tag("<p>", "</p>"));
	map.put("section", new Tag("<h3>", "</h3>"));
	map.put("li", new Tag("<li>", "</li>"));
	map.put("ul", new Tag("<ul>", "</ul>"));
	map.put("pre", new Tag("<pre>", "</pre>"));
	htmlTagMap = map;

	map = new HashMap<String, Tag>();
	map.put("code", new Tag("\\Scode{", "}"));
	map.put("arg", new Tag("\\Sarg{", "}"));
	map.put("em", new Tag("\\Semph{", "}"));
	map.put("note", new Tag("\n\\Snote{", "}"));
	map.put("see", new Tag("\n\\Ssee{", "}"));
	map.put("p", new Tag("\n", "\n"));
	map.put("section", new Tag("\\Ssection{", "}"));
	map.put("li", new Tag("\n\\Sli ", "\n"));
	map.put("ul", new Tag("\n\\begin{Sul}\n", "\n\\end{Sul}\n"));
	texTagMap = map;
    }

    /**
       ɥȤޤ

       @param packageName ɥȤ°ѥå̾
       @param name ɥȤ°륰롼פ̾
       @param nodes descǤΥΡɥꥹ
    */
    private Description(final String packageName, final String name,
			final NodeList nodes) {
	if (nodes.getLength() == 0) {
	    return;
	}
	descElem = (Element) nodes.item(0);
	this.packageName = packageName;
	namespace = packageName + "." + name;
	idManager = IDManager.getInstance();
    }

    /**
       ɥȤޤ

       @param packageName ɥȤ°ѥå̾
       @param nodes descǤΥΡɥꥹ
    */
    public Description(final String packageName, final NodeList nodes) {
	if (nodes.getLength() == 0) {
	    return;
	}
	descElem = (Element) nodes.item(0);
	this.packageName = packageName;
	namespace = packageName;
	idManager = IDManager.getInstance();
    }

    /**
       ɥȤޤ

       @param location ֤̾ΰ
       @param nodes descǤΥΡɥꥹ
    */
    public Description(final Location location, final NodeList nodes) {
	this(location.getPackageName(), location.getClassName(), nodes);
    }

    /**
       ɥȤޤ

       @param group 롼
       @param nodes descǤΥΡɥꥹ
    */
    public Description(final Group group, final NodeList nodes) {
	this(group.getPackageName(), group.getName(), nodes);
    }

    /**
       ΥɥȤޤ
    */
    public Description() {
    }

    /**
       ɥȤHTMLǼޤ

       @return HTMLΥɥ
    */
    public String getText() {
	if (descElem == null) {
	    return "";
	}
	return getDescription((Node) descElem);
    }

    /**
       ɥȤHTMLǼޤ

       ǽbriefƤ֤ޤ

       @return HTMLΥɥȤ
    */
    public String getBriefText() {
	if (descElem == null) {
	    return "";
	}
	NodeList nodes = descElem.getElementsByTagName("brief");
	if (nodes.getLength() == 0) {
	    return "";
	}
	return getDescription((Node) nodes.item(0));
    }

    /**
       descǤ˴ޤޤǤΥɥȤHTMLǼޤ

       ƵŪǤ򤿤ɤޤ

       @param node descǤ˴ޤޤ
       @return HTMLΥɥ
    */
    private String getDescription(final Node node) {
        String s = "";
        NodeList children = node.getChildNodes();
        for (int i = 0; i < children.getLength(); ++i) {
            Node child = children.item(i);
	    String nodeName = child.getNodeName();
	    Tag tag;
            if (child.getNodeType() == Node.TEXT_NODE) {
		s += idManager.getHTML(packageName, child.getNodeValue());
	    } else if (nodeName.equals("math")) {
		s += Html.math(getRawText(child));
	    } else if ((tag = htmlTagMap.get(nodeName)) != null) {
                s += tag.create(getDescription(child));
	    } else {
                String pre = "", post = "";
	        if (nodeName.equals("a")) {
		    Element elem = (Element) child;
		    String attr = elem.getAttribute("href");
		    pre = "<a href='" + attr + "'>";
		    post = "</a>";
		} else if (nodeName.equals("hyperlink")) {
		    Element elem = (Element) child;
		    String attr, sep;
		    String ns = elem.getAttribute("namespace");
		    String label = elem.getAttribute("label");
		    if (ns.equals("")) {
			ns = namespace;
		    }
		    if (ns.indexOf('.') == -1) {
			attr = "index.html#" + ns;
			sep = "_";
		    } else {
			attr = ns.replace('.', '_') + ".html";
			sep = "#";
		    }
		    if (!label.equals("")) {
			attr += sep + label;
		    }
		    pre = "<a href='" + attr + "'>";
		    post = "</a>";
		} else if (nodeName.equals("hypertarget")) {
		    Element elem = (Element) child;
		    String label = elem.getAttribute("label");
		    if (namespace.indexOf('.') == -1) {
			label = namespace + "_" + label;
		    }
		    pre = "<a name='" + label + "'" + ">";
		    post = "</a>";
		}
                s += pre + getDescription(child) + post;
	    }
        }
        return s;
    }

    /**
       ɥȤTeXǼޤ

       @return TeXΥɥ
    */
    public String getTexText() {
	if (descElem == null) {
	    return "";
	}
	return getTexDescription((Node) descElem);
    }

    /**
       Ρɤ˴ޤޤɥȤǼޤ

       @param node Ρ
       @return Ρɤ˴ޤޤɥ
    */
    private String getRawText(final Node node) {
        String s = "";
        NodeList children = node.getChildNodes();
        for (int i = 0; i < children.getLength(); ++i) {
            Node child = children.item(i);
            if (child.getNodeType() == Node.TEXT_NODE) {
		s += child.getNodeValue();
	    }
	}
	return s;
    }

    /**
       descǤ˴ޤޤǤΥɥȤTeXǼޤ

       ƵŪǤ򤿤ɤޤ

       @param node descǤ˴ޤޤ
       @return TeXΥɥ
    */
    private String getTexDescription(final Node node) {
        String s = "";
        NodeList children = node.getChildNodes();
        for (int i = 0; i < children.getLength(); ++i) {
            Node child = children.item(i);
	    String nodeName = child.getNodeName();
	    Tag tag;
            if (child.getNodeType() == Node.TEXT_NODE) {
		s += idManager.getTEX(packageName, child.getNodeValue());
	    } else if (nodeName.equals("math")) {
		s += Tex.math(getRawText(child));
	    } else if (nodeName.equals("pre")) {
		String pre = "\n\\begin{Spre}\\begin{verbatim}";
		String post = "\\end{verbatim}\\end{Spre}\n";
		s += pre + getRawText(child) + post;
	    } else if ((tag = texTagMap.get(nodeName)) != null) {
                s += tag.create(getTexDescription(child));
	    } else {
                String pre = "", post = "";
		if (nodeName.equals("a")) {
		    Element elem = (Element) child;
		    String url = elem.getAttribute("href");
		    if (!url.equals("")) {
			pre = "\\Shref{" + Tex.safeURL(url) + "}{";
			post = "}";
		    }
		} else if (nodeName.equals("hyperlink")) {
		    Element elem = (Element) child;
		    String ns = elem.getAttribute("namespace");
		    if (ns.equals("")) {
			ns = namespace;
		    }
		    String label = elem.getAttribute("label");
		    if (label.equals("")) {
			pre = "\\Sanchor{:" + Tex.safeTarget(ns) + ":}{";
			post = "}";
		    } else {
			pre = "\\Shyperlink{:" + Tex.safeTarget(ns) + ":"
			    + Tex.safeTarget(label) + "}{";
			post = "}";
		    }
		} else if (nodeName.equals("hypertarget")) {
		    Element elem = (Element) child;
		    String label
			= ":" + Tex.safeTarget(namespace)
			+ ":" + Tex.safeTarget(elem.getAttribute("label"));
		    pre = "\\Shypertarget{" + label + "}{";
		    post = "}";
		}
                s += pre + getTexDescription(child) + post;
	    }
        }
        return s;
    }
}
