package com.maroontress.sanctuary;

import java.io.PrintWriter;
import org.w3c.dom.Element;

/**
   ؿޤϴؿݥ󥿤Ǥ
*/
public class Function {

    /** HTMLϤǲԤʤͤηפκĹ */
    static final int HTML_RETURN_TYPE_MAX_LEN = 20;

    /** 롼 */
    private Group group;

    /** ؿ̾ */
    private QualifiedName name;

    /** ؿΰ */
    private MethodParameters params;

    /** ؿν */
    private Modifiers modifiers;

    /** ؿ */
    private Return returnElem;

    /** ؿ */
    private Description desc;

    /**
       ؿޤϴؿݥ󥿤ޤ

       @param group 롼
       @param name ̾
       @param desc 
       @param elem (abstract)methodǤޤmethodmember
    */
    public Function(final Group group, final QualifiedName name,
		    final Description desc, final Element elem) {
	this.group = group;
	this.name = name;
	this.desc = desc;

	ChildrenFilter c = new ChildrenFilter(elem);
	params = new MethodParameters(
	    group, c.getDirectChildrenByTagName("param"),
	    c.getDirectChildrenByTagName("variableparam"));
	modifiers = new Modifiers(c.getDirectChildrenByTagName("modifier"));
	returnElem = new Return(group, c.getDirectChildrenByTagName("return"));
    }

    /**
       ѥ᡼ޤ

       @param k 
       @param param ѥ᡼
    */
    public void insertParameter(final int k, final Parameter param) {
        params.insert(k, param);
    }

    /**
       饳ɤ륤󥿥ե
    */
    private interface ParameterCoder {
	/**
	   饳ɤޤ

	   @param param 
	   @return 
	*/
	String getCode(Parameter param);
    };

    /**
       ץȥϤޤ

       @param wr 饤
       @param indent ǥʸ
       @param opener ץȥ˽Ϥʸ
       @param closer ץȥθ˽Ϥʸ
       @param pre ؿ̾˽Ϥʸ
       @param post ؿ̾θ˽Ϥʸ
       @param withModifiers ҤϤtrue
       @param coder Υɤ륤󥿥ե
    */
    private void writePrototype(final PrintWriter wr, final String indent,
				final String opener, final String closer,
				final String pre, final String post,
				final boolean withModifiers,
				final ParameterCoder coder) {
	Parameter p = params.getParameter(0);
	String arg = (p == null) ? "void" : p.getCode();
	String s = opener + returnElem.getLeftCode() + pre + name + post + "(";
	int len = s.length();
	char[] space = new char[len];
	for (int i = 0; i < len; ++i) {
	    space[i] = ' ';
	}
	String offset = new String(space);
	wr.print(indent + s + arg);
	for (int k = 1; (p = params.getParameter(k)) != null; ++k) {
	    wr.print(",\n" + indent + offset + coder.getCode(p));
	}
	String m = withModifiers ? modifiers.getCode() : "";
	wr.println(")" + returnElem.getRightCode() + m + closer);
    }

    /**
       ץȥϤޤ

       @param wr 饤
       @param indent ǥʸ
       @param opener ץȥ˽Ϥʸ
       @param closer ץȥθ˽Ϥʸ
       @param pre ؿ̾˽Ϥʸ
       @param post ؿ̾θ˽Ϥʸ
       @param withModifiers ҤϤtrue
    */
    public void printPrototype(final PrintWriter wr, final String indent,
			       final String opener, final String closer,
			       final String pre, final String post,
			       final boolean withModifiers) {
	writePrototype(wr, indent, opener, closer, pre, post, withModifiers,
		       new ParameterCoder() {
			   public String getCode(final Parameter p) {
			       return p.getCode();
			   }
		       });
    }

    /**
       ֤ΥץȥϤޤ

       @param wr 饤
       @param indent ǥʸ
       @param opener ץȥ˽Ϥʸ
       @param closer ץȥθ˽Ϥʸ
       @param pre ؿ̾˽Ϥʸ
       @param post ؿ̾θ˽Ϥʸ
       @param withModifiers ҤϤtrue
    */
    public void printStubPrototype(final PrintWriter wr, final String indent,
				   final String opener, final String closer,
				   final String pre, final String post,
				   final boolean withModifiers) {
	writePrototype(wr, indent, opener, closer, pre, post, withModifiers,
		       new ParameterCoder() {
			   public String getCode(final Parameter p) {
			       return p.getStubCode();
			   }
		       });
    }

    /**
       ֤ΥɤϤޤ

       @param wr 饤
    */
    public void printStubCode(final PrintWriter wr) {
	Parameter p;
	int k;

	String returnValueDeclare = "";
	String returnValueAssign = "";
	String returnValueReturn = "";
	if (!returnElem.getHTML(group).equals("void")) {
	    returnValueDeclare = "    " + returnElem.getLeftCode()
		+ "_val" + returnElem.getRightCode() + ";\n";
	    returnValueAssign = "_val = ";
	    returnValueReturn = "    return _val;\n";
	}

	String vaList = "";
	String vaStart = "";
	String vaEnd = "";
	for (k = 0; (p = params.getParameter(k)) != null
		 && !(p instanceof VariableParameter); ++k) {
	    continue;
	}
	if (p != null && k > 0) {
	    Parameter last = params.getParameter(k - 1);
	    vaList
		= "    va_list _ap;\n";
	    vaStart
		= "    va_start(_ap, " + last.getName() + ");\n";
	    vaEnd
		= "    va_end(_ap);\n";
	}

	wr.println("");
	printStubPrototype(wr, "", "", " = NULL;", "(*stub_", ")", false);
	printPrototype(wr, "", "", "", "", "", false);
	wr.println("{");
	wr.print(returnValueDeclare);
	wr.print(vaList);
	if (!returnValueDeclare.equals("") || !vaList.equals("")) {
	    wr.println("");
	}
	wr.print(vaStart);
	wr.print(""
		 + "    if (stub_" + name + " == NULL)\n"
		 + "        abort();\n"
		 + "    " + returnValueAssign + "stub_" + name + "(");
	p = params.getParameter(0);
	String arg = (p == null) ? "" : p.getName();
	wr.print(arg);
	for (k = 1; (p = params.getParameter(k)) != null; ++k) {
	    String param;
	    if (p instanceof VariableParameter) {
		param = "_ap";
	    } else {
		param = p.getName();
	    }
	    wr.print(", " + param);
	}
	wr.print(");\n");
	wr.print(vaEnd);
	wr.print(returnValueReturn);
	wr.print("}\n");
    }

    /**
       HTMLǽϤޤ

       @param wr 饤
       @param fragment 
       @param pre ؿ̾˽Ϥʸ
       @param post ؿ̾θ˽Ϥʸ
    */
    public void printSummary(final PrintWriter wr, final String fragment,
			     final String pre, final String post) {
	String m = group.getHTML(modifiers.getCode());

	wr.println(""
+ "<tr>\n"
+ "  <td align=\"right\" valign=\"top\" width=\"1%\">\n"
+ "    <font size=\"-1\">&nbsp;" + returnElem.getHTML(group)
+ "</font>\n"
+ "  </td>\n"
+ "  <td valign=\"top\">"
+ pre + "<a href=\"#" + fragment + "\">"
+ "<b>" + Html.safe(name.getSimple()) + "</b></a>"
+ post + "(" + params.getHTML(group) + ")" + m + "<br>"
+ "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
+ desc.getBriefText() + "</td>\n"
+ "</tr>");
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
       @param fragment 
       @param pre ؿ̾˽Ϥʸ
       @param post ؿ̾θ˽Ϥʸ
    */
    public void printDetail(final PrintWriter wr, final String fragment,
			    final String pre, final String post) {
	Parameter p = params.getParameter(0);
	String arg = (p == null) ? "void" : p.getHTML(group);
	String returnType = returnElem.getHTML(group);
	String returnTypeText = returnType.replaceAll("<[^>]+>", "");
	String m = group.getHTML(modifiers.getCode());

	wr.print(""
+ "<p><a name=\"" + fragment + "\"></a>"
+ "<font size=\"+1\"><b>" + Html.safe(name.getSimple())
+ "</b></font></p>\n");

	if (params.getParameter(0) != null
	    && returnTypeText.length() > HTML_RETURN_TYPE_MAX_LEN) {
	    wr.print(""
+ "<table cellpadding=\"0\" cellspacing=\"0\">\n"
+ "  <tr>\n"
+ "    <td nowrap>" + returnType + "</td>\n"
+ "  </tr>\n"
+ "</table>\n"
+ "<table cellpadding=\"0\" cellspacing=\"0\">\n"
+ "  <tr>\n"
+ "    <td nowrap>"
+ "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
+ pre + "<b>" + name.getSimple() + "</b>" + post + "(</td>\n"
+ "    <td nowrap>" + arg);
	} else {
	    wr.print(""
+ "<table cellpadding=\"0\" cellspacing=\"0\">\n"
+ "  <tr>\n"
+ "    <td nowrap>" + returnElem.getHTML(group) + " "
		    + pre + "<b>" + name.getSimple() + "</b>"
		    + post + "(</td>\n"
+ "    <td nowrap>" + arg);
	}

	for (int k = 1; (p = params.getParameter(k)) != null; ++k) {
	    wr.print(""
+ ",</td>\n"
+ "  </tr>\n"
+ "  <tr>\n"
+ "    <td></td><td nowrap>" + p.getHTML(group));
	}
	wr.println(""
+ ")" + m + "</td>\n"
+ "  </tr>\n"
+ "</table>\n"
+ "<dl>\n"
+ "<dd>" + desc.getText() + "</dd>\n");

	params.printDetail(wr);
	returnElem.printDetail(wr);

	wr.println(""
+ "</dl>");
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
       @param fragment 
       @param secType μɽʸ"id" ޤ "member"
       @param opener ܺ٤˽Ϥʸ
       @param closer ܺ٤θ˽Ϥʸ
       @param pre ؿ̾˽Ϥʸ
       @param post ؿ̾θ˽Ϥʸ
    */
    public void printTexDetail(final PrintWriter wr,
			       final String fragment,
			       final String secType,
			       final String opener, final String closer,
			       final String pre, final String post) {
	Parameter p = params.getParameter(0);
	String texName = Tex.safe(name.getSimple());
	String texModifier = Tex.safe(modifiers.getCode());
	String ns = group.getPackageName() + "." + group.getName();
	String texLabel = Tex.safeTarget(ns + "." + fragment);
	String arg, lf, indent;

	if (p == null) {
	    arg = "void";
	    lf = "";
	    indent = "";
	} else {
	    arg = p.getTEX(group);
	    lf = "\\\\\n";
	    indent = "\\Sindent ";
	}

	wr.println("");
	wr.println("\\S" + secType + "{" + texName + "}");
	wr.println("\\Slabel{:" + texLabel + ":}");
	wr.println("\\nopagebreak");
	if (!opener.equals("")) {
	    wr.println(opener);
	}

	// Syntax
	wr.println("\\begin{Ssyntax}%");
	wr.print(returnElem.getTEX(group) + " "
		 + pre + "{\\bfseries " + texName + "}" + post + "("
		 + lf + indent + arg);

	for (int k = 1; (p = params.getParameter(k)) != null; ++k) {
	    wr.println(",\\\\");
	    wr.println(indent);
	    wr.print(p.getTEX(group));
	}
	wr.println(")" + texModifier);
	wr.println("\\end{Ssyntax}");

	// Description
	wr.println("");
	wr.println(desc.getTexText());

	// Parameters
	params.printTexDetail(wr);

	// Returns
	returnElem.printTexDetail(wr);

	if (!closer.equals("")) {
	    wr.println(closer);
	}
    }
}
